angular.module('beamng.apps')
	.directive('jamie599sTintable', [function () {
		return {
			templateUrl: '/ui/modules/apps/Jamie599s_Tintable/app.html',
			replace: true,
			restrict: 'EA',
			link: function (scope, element, attrs) {

				scope.categories = ["Glass", "Door Glass", "Quarter Glass"];
				scope.tintable_parts = {};
				scope.variables = {};
				scope.variables.tintInside = true;
				scope.variables.allTintablePartsEquipped = false;
				scope.variables.anyTintableEquipped = false;
				scope.variables.vehSupportsTintable = false;
				scope.variables.liveUpdate = true;
				scope.previousCategory = null;
				// scope.tintInside = false

				scope.small = true
				scope.toggleSmall = () => {
					getTintableParts();
					scope.small = !scope.small
				}

				scope.$on('VehicleChange', getTintableParts)
				scope.$on('VehicleFocusChanged', getTintableParts)

				getTintableParts();

				function getTintableParts() {
					bngApi.engineLua('scripts_Jamie599s__Tintable_extension.getTintableParts()', function (result) {
						allTintablePartsEquipped();
						vehSupportsTintable();
						anyTintableEquipped();
						// console.info(JSON.stringify(result));
						if (angular.equals(result, {}) == false) {
							scope.tintable_parts = result.sort(compareByCategoryAndName);
						} else {
							scope.tintable_parts = {};
						}

						// // console.info(JSON.stringify(result));
						for (part in scope.tintable_parts) {
							// console.info(part);
							// console.info(JSON.stringify(scope.tintable_parts[part]));
						}
						scope.previousCategory = null;
						// scope.$evalAsync();
					});
				}

				function allTintablePartsEquipped() {
					bngApi.engineLua('scripts_Jamie599s__Tintable_extension.tintablePartsToAdd()', function (result) {
						// console.info("allTintablePartsEquipped: " + result);
						scope.variables.allTintablePartsEquipped = result;
					});
				}

				function anyTintableEquipped() {
					bngApi.engineLua('scripts_Jamie599s__Tintable_extension.anyTintableEquipped()', function (result) {
						// console.info("anyTintableEquipped: " + result);
						scope.variables.anyTintableEquipped = result;
					});
				}

				function vehSupportsTintable() {
					bngApi.engineLua('scripts_Jamie599s__Tintable_extension.vehSupportsTintable()', function (result) {
						// console.info("vehSupportsTintable: " + result);
						scope.variables.vehSupportsTintable = result;
					});
				}

				// The current overlay screen the user is on (default: null)
				scope.overlayScreen = null;

				scope.equipTintableParts = function () {
					bngApi.engineLua('scripts_Jamie599s__Tintable_extension.addTintableParts()', function () {
						getTintableParts();
						scope.setTint();
					});
				};

				scope.setTint = function (overwrite, partToUpdate = null, partToUpdateTint = null) {
					// console.info("selected part " + partToUpdate)
					if (scope.variables.liveUpdate || overwrite) {
						// console.info("setTint");
						if (partToUpdate == null) {
							// console.info("setTint all");
							for (part in scope.tintable_parts) {
								// console.info(part);
								// console.info(JSON.stringify(scope.tintable_parts[part]));
								// console.info(scope.variables.tintInside)
								bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + scope.tintable_parts[part].part + '", ' + scope.tintable_parts[part].tint + ', 0)');
								if (scope.variables.tintInside) {
									bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + scope.tintable_parts[part].part + '", ' + scope.tintable_parts[part].tint + ', 1)');
								} else {
									bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + scope.tintable_parts[part].part + '", ' + 0 + ', 1)');
								}
								bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + scope.tintable_parts[part].part + '", ' + scope.tintable_parts[part].tint + ', 2)');
							}
						} else {
							// console.info("setTint single");
							// console.info(partToUpdate);
							// console.info(partToUpdateTint);
							bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + partToUpdate + '", ' + partToUpdateTint + ', 0)');
							if (scope.variables.tintInside) {
								bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + partToUpdate + '", ' + partToUpdateTint + ', 1)');
							} else {
								bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + partToUpdate + '", ' + 0 + ', 1)');
							}
							bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + partToUpdate + '", ' + partToUpdateTint + ', 2)');
						}
					}

					// bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("Jamie599s_etk800_windshield_tintable", '+  +')');
				}

				scope.resetTint = function () {
					// console.info("resetTint");
					for (part in scope.tintable_parts) {
						bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + scope.tintable_parts[part].part + '", ' + 100 + ', 0)');
						bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + scope.tintable_parts[part].part + '", ' + 100 + ', 1)');
						bngApi.engineLua('scripts_Jamie599s__Tintable_extension.setTint("' + scope.tintable_parts[part].part + '", ' + 100 + ', 2)');
					}
					getTintableParts();
				}

				scope.wasPreviousCategory = function (category) {
					if (scope.previousCategory == null) {
						scope.previousCategory = category;
						return false;
					}

					if (scope.previousCategory == category) {
						return true;
					}

					scope.previousCategory = category;
					return false;
				}

				const compareByCategoryAndName = (a, b) => {
					if (a.category < b.category) {
						return -1;
					} else if (a.category > b.category) {
						return 1;
					} else {
						if (a.name < b.name) {
							return -1;
						} else if (a.name > b.name) {
							return 1;
						} else {
							return 0;
						}
					}
				};
			}
		};
	}]);